<template>
	<transition name="slide-fade">
		<div :class="responsiveClassSidebar" >
			<div class="toggle-content"  @click.prevent="toggleSidebarResponsive()"><a href="#"><i class="  ti-book" ></i></a></div>
			<div class=" custom-scroll custom-scroll-dark">
				<div class="content-title">
					<h4> {{ courseBuilderInfo.name }} </h4>
					<p> {{ courseBuilderInfo.grade }} </p>
					<div class="btn-save-general"> 
						<button v-if="closeCourse" type="button" class="ml-2 btn btn-info btn-circle  waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Guardar Todo" @click.prevent="storeNewCourse">
						<i class="ti-save "></i>
						</button>
						<button type="button" class="ml-2 btn btn-success btn-circle  waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Vista previa" @click.prevent="showPreview">
						<i class="ti-eye "></i>
						</button>
						<button v-if="closeCourse" type="button" class="ml-2 btn btn-info btn-circle  waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Curso cerrado" @click="unlockCourse">
							<i class="fa fa-lock"></i>
						</button>
						<button v-else type="button" class="ml-2 btn btn-danger btn-circle  waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Curso Abierto" @click="unlockCourse">
							<i class="fa fa-unlock"></i>
						</button>
					</div>
				</div>
				<div class="content-sesiones">
					<div class="panel panel-success">
						<template v-for="(weeks, week_index) in courseBuilderWeeks">
							<ul class="nav  tabs-nav" role="tablist" :key="week_index">
								<li class="nav-item ">
									<a 
									   :href="`#collapse-${week_index + 1}`"
									   :aria-controls="`tema-${week_index + 1}`" 
									   class="nav-link semana"
									   role="tab" data-toggle="collapse" aria-expanded="true"
									    >
										<b> {{ `Semana ${week_index + 1}: ` }} <input class="transparent-input" type="text" v-model="weeks.name"> </b> 
										<button class="btn btn-danger btn-rounded btn-sm pull-right" v-if="weeks.sessions.length == 0 && week_index > 0" @click.prevent="deleteWeek(week_index)">
											<i class="pull-right ti ti-minus"></i>
										</button>
									</a>
								</li>
							</ul>
							<div :id="`collapse-${week_index + 1}`" class="panel-collapse collapse in" :key="week_index">
								<draggable @end="showToast" element="ul" class="list-group" v-model="weeks.sessions" :options="{ sort: canBeSorted, group: { pull: 'move' }}">
									<li :class="defineClass(session)" v-for="(session, session_index) in weeks.sessions" v-if="session.type=='content'" :key="session_index">
										<a 
											@click.prevent="changeSession(week_index, session_index)" 
											:aria-controls="`tema-${week_index + 1}`"
											:style="!isEditing ? 'cursor:pointer;' : 'cursor:not-allowed;'" 
											:class="`${session.completed ? 'nav-link active' : 'nav-link '}  ${isSessionActive(week_index, session_index) ? 'session-selected' : ''} `"
											role="tab" data-toggle="tab" aria-expanded="true" >
											<span>
												{{ session.name }}
											</span>
											<span class="tag tag-pill pull-right" :class="session.builtPercentage == 100 ? 'tag-complete' : 'tag-incomplete'">
												{{ `${session.builtPercentage.toString().slice(0, 4)}` }}%
											</span>
										</a>
									</li>
								</draggable>
								<ul id="ev" class="list-group" v-for="(session, session_index) in weeks.sessions" v-if="session.type=='quiz' || session.type=='eval'" :key="session_index">
									<li :class="defineClass(session)">
										<a 
											@click.prevent="changeSession(week_index, session_index)" 
											:aria-controls="`tema-${week_index + 1}`"
											style="cursor:pointer;" 
											:class="`${session.completed ? 'nav-link active' : 'nav-link '}  ${isSessionActive(week_index, session_index) ? 'session-selected' : ''} `"
											role="tab" data-toggle="tab" aria-expanded="true">
											<span>
												{{ session.name }}
											</span>
											<span class="tag tag-pill pull-right" :class="session.builtPercentage == 100 ? 'tag-complete' : 'tag-incomplete'">
												{{ `${session.builtPercentage.toString().slice(0, 4)}` }}%
											</span>
										</a>
									</li>
								</ul>
							</div>
						</template>
					</div>
				</div>
			</div>
		</div>
	</transition>
</template>

<script>

import api from '../../api'
import draggable from 'vuedraggable'
import { mapGetters, mapActions } from 'vuex'
export default {
	components : {
		draggable
	},
	data(){
		return {
			id: -1,
			closeCourse:true,
		}
	},
	watch:{
		
	},
	computed: {
		...mapGetters([
			'isEditing',
			'currentSessionIndexes',
			'courseBuilder',
			'courseBuilderInfo',
			'courseBuilderWeeks',
			'hasStartedSessionBuilder',
			'sidebarResponsive',
			'current_user',
		]),
		courseLoaded() {
			return this.course.name != ''
		},
		responsiveClassSidebar(){
			let _class = "content-sidebar session-bar "
			if(this.sidebar)
				_class+="col-md-1 "
			else
				_class+="col-md-3 "
			if(this.sidebarResponsive)
				_class+="sidebar-responsive2"
			return _class
		},
		canBeSorted() {
			return !this.hasStartedSessionBuilder
		},
	    list: {
	      get() {
	        return this.courseBuilderWeeks
	      },
	      set(item) {
	        this.updateCourseBuilderList(item)
	      }
	    },		
	},
	methods: {
		showToast(){
			toastr.success('Sesión reordenada exitosamente')
		},
        confirm(type) {
            this.displayModal(type)
        },
		isSessionActive(week_index, session_index){
			return week_index == this.currentSessionIndexes.week && session_index == this.currentSessionIndexes.session
		},
		defineClass(session) {
			let type = (session.type == 'quiz' || session.type == 'eval' ) ? 'nav-li nav-evaluacion' : 'nav-li'
			return session.completed ? `nav-item ${type} activo` : `nav-item ${type}`
		},
		...mapActions([
			'changeCurrentBuilderSession',
			'deleteWeek',
			'storeCourse',
			'storeCoursePreview',
			'getCourseInfo',
			'getUser',
			'displayModal',
			'toggleSidebarResponsive',
		]),
		storeNewCourse(){
			let fd = new FormData();
			let content = JSON.stringify(this.courseBuilder);
                fd.append("content", content);
				fd.append("subject_id", this.id);

			this.storeCourse(fd).then( ok =>{
					if(ok){
						window.location.reload()
					}
			})
		},
		unlockCourse(){
			let id = window.location.href.split('/').pop()
			if(this.closeCourse){
				//liberar
				if(confirm('¿Guardaste tus cambios?')){
					api.endCourseLog({id: id }).then( ({ok}) =>{
						window.location = '/home'
					})
					this.closeCourse = false;
				}
			
			}else{
				api.storeCourseLog({user_id : this.current_user.id, subject_id: this.id }).then( ({ok}) =>{
					if(ok){
						this.closeCourse = true
					}else{
						toastr.error('El curso ya está siendo usado.', 'Oops!')
					}
				})
			}
			
				
		},
		/*unlockCourse(){
				let id = window.location.href.split('/').pop()
				api.endCourseLog({id: id }).then( ({ok}) =>{
					window.location = '/home'
			})
		},*/

		showPreview(){
			let fd = new FormData();
			let content = JSON.stringify(this.courseBuilder);
                fd.append("content", content);
				fd.append("subject_id", this.id);

			this.storeCoursePreview(fd).then( ok =>{
					if(ok){
						window.open(`/course-preview/${this.id}`)
					}
			})
		},
		changeSession(week_index, session_index) {
			if (!this.hasStartedSessionBuilder){
				this.changeCurrentBuilderSession({ week: week_index, session: session_index })
			}
			else{
				toastr.error('No es posible editar otra sesión por el momento.', 'Oops!')
			}
				
				
		},


	},
	created(){
			this.id = window.location.href.split('/').pop()
			this.getUser().then( ()=>{
				api.storeCourseLog({user_id : this.current_user.id, subject_id: this.id }).then( ({ok}) =>{
					if(!ok){
						$(window).bind('beforeunload', function(e){})
						window.history.back();
					}
				})
			})
			this.getCourseInfo(this.id)
		}
}

</script>
<style>

.session-selected{
	background: rgba(0,0,0,0.25)!important;
	color: white !important;
}

.slide-fade-enter-active {
	transition: all .3s ease;
}

.slide-fade-leave-active {
	transition: all .8s cubic-bezier(1.0, 0.5, 0.8, 1.0);
}

.slide-fade-enter,
.slide-fade-leave-to
/* .slide-fade-leave-active below version 2.1.8 */

{
	transform: translateX(10px);
	opacity: 0;
}

.no-pad {
	padding-right: 0px !important;
	padding-left: 0px !important;
}

.transparent-input {
    outline: none;
    border: 0px;
    background: transparent;
}

</style>